//-----------------------------------------------------------
// smpl10(spi_ata6831).c
// SPIڑ̃n[tubWhCo(ATA6831)Ƃ̒ʐM
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// ATA6831̏ڍׂ͈ȉ
//  http://www.atmel.com/dyn/products/product_card.asp?part_id=4055
// SPȊMPDCgpB
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#define _PB1  ((uint32_t)1 << 21) // PA21 -> PB1
#define _PB2  ((uint32_t)1 << 22) // PA22 -> PB2
#define _ALL_PB  (_PB1 | _PB2)
static const TPin pins[] = {
  // PA16 -> SPI0(MISO)
  {1 << 16,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_PULLUP},
  // PA17 -> SPI0(MOSI)
  {1 << 17,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA18 -> SPI0(SPCK)
  {1 << 18,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA13 -> SPI0(NPCS1) -> LIS331DL
  {1 << 13,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA14 -> SPI0(NPCS2) -> ATA6831
  {1 << 14,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},

  // PB27 -> PWM0
  {1 << 27,       &PIOB, PIOB_PID, PIO_PERIPH_B, PIO_DEFAULT},

  // PB1, PB2
  {_ALL_PB,       &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};

#define SPI SPI0

#else
static const TPin pins[] = {
#define _PB1  ((uint32_t)1 << 17) // PA17 -> PB1
#define _PB2  ((uint32_t)1 << 18) // PA18 -> PB2
#define _ALL_PB  (_PB1 | _PB2)

  // PA12 -> SPI(MISO)
  {1 << 12,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_PULLUP},
  // PA13 -> SPI(MOSI)
  {1 << 13,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA14 -> SPI(SPCK)
  {1 << 14,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA31 -> SPI(NPCS1) -> LIS331DL
  {1 << 31,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA30 -> SPI(NPCS2) -> ATA6831
  {1 << 30,       &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_DEFAULT},

  // PA23 -> PWM0
  {1 << 23,       &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_DEFAULT},

  // PB1, PB2
  {_ALL_PB,       &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};
#endif

int duty;

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// SPI
//========================================================
// TX & RX (use PDC)
void SPI_SendReceive (void *tbuf, void *rbuf, int len) {
  // Check if first bank is free
  while (!(SPI.SR & _SPI_ENDTX)) ;
  if (SPI.PDC.TCR == 0) {
    SPI.PDC.RPR = rbuf;
    SPI.PDC.RCR = len;
    SPI.PDC.TPR = tbuf;
    SPI.PDC.TCR = len;
    SPI.PDC.PTCR = _PDC_TXTEN;
  }
  // Check if second bank is free
  else if (SPI.PDC.TNCR == 0) {
    SPI.PDC.RNPR = rbuf;
    SPI.PDC.RNCR = len;
    SPI.PDC.TNPR = tbuf;
    SPI.PDC.TNCR = len;
  }
  while (!(SPI.SR & _SPI_ENDRX)) ;
}

// Init SPI
void SPI_Init (void) {
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
  PMC.PCER = 1 << SPI0_PID;
#else
  PMC.PCER = 1 << SPI_PID;
#endif
  SPI.PDC.PTCR = _PDC_RXTDIS | _PDC_TXTDIS;
  SPI.CR = _SPI_SWRST | _SPI_SPIDIS;
  SPI.MR = _SPI_MSTR | _SPI_PS | _SPI_PS_FIXED | _SPI_MODFDIS | (0xf << 16);

  // ATA6831
  SPI.CSR[2] =           /*_SPI_NCPHA |*/_SPI_CSAAT | _SPI_BITS_16 | ((uint32_t) 24 << 8);

  SPI.PDC.TNPR = SPI.PDC.RNPR = SPI.PDC.TPR = SPI.PDC.RPR = (uint8_t *)0;
  SPI.PDC.TNCR = SPI.PDC.RNCR = SPI.PDC.TCR = SPI.PDC.RCR = 0;
  SPI.PDC.PTCR = _PDC_RXTEN | _PDC_TXTEN;

  SPI.CR = _SPI_SPIEN;
}

//========================================================
// ATA6831 I/F
//========================================================
uint16_t SPI_ATA6831_Send (uint16_t senddata) {
  volatile uint32_t tbuf = 0xb0000 | _SPI_LASTXFER | senddata, rbuf;
  SPI_SendReceive ((void *)&tbuf, (void *)&rbuf, 1);
  return rbuf & 0xffff;
}

#define _SRR 0x8000

#define _LS1 0x4000
#define _HS1 0x2000
#define _LS2 0x1000
#define _HS2 0x0800
#define _LS3 0x0400
#define _HS3 0x0200

#define _PL1 0x0100
#define _PH1 0x0080
#define _PL2 0x0040
#define _PH2 0x0020
#define _PL3 0x0010
#define _PH3 0x0008

#define _OLD 0x0004
//#define _OSC 0x0002
#define _OSC 0x0000
#define _SI  0x0001

#define _ENM  (_SRR | _SI | _OLD)

void st(uint16_t in, uint16_t out) {
  _us_printf (
    "\033[2JTX :"
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "\nRX :"
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "%s "
    "\nduty:%5d",

    (in & _SRR) ? "SRR" : "   ",
    (in & _LS1) ? "LS1" : "   ",
    (in & _HS1) ? "HS1" : "   ",
    (in & _LS2) ? "LS2" : "   ",
    (in & _HS2) ? "HS2" : "   ",
    (in & _LS3) ? "LS3" : "   ",
    (in & _HS3) ? "HS3" : "   ",

    (in & _PL1) ? "PL1" : "   ",
    (in & _PH1) ? "PH1" : "   ",
    (in & _PL2) ? "PL2" : "   ",
    (in & _PH2) ? "PH2" : "   ",
    (in & _PL3) ? "PL3" : "   ",
    (in & _PH3) ? "PH3" : "   ",

    (out & 0x8000) ? "TP " : "   ",
    (out & 0x4000) ? "LS1" : "   ",
    (out & 0x2000) ? "HS1" : "   ",
    (out & 0x1000) ? "LS2" : "   ",
    (out & 0x0800) ? "HS2" : "   ",
    (out & 0x0400) ? "LS3" : "   ",
    (out & 0x0200) ? "HS3" : "   ",

    (out & 0x0004) ? "OVL" : "   ",
    (out & 0x0002) ? "INH" : "   ",
    (out & 0x0001) ? "PSF" : "   ",

    PWM.CHANNEL[0].CDTY
  );
}

//========================================================
// PWM
//========================================================
void update_period (int ch, uint16_t period) {
  ch &= 3;
  bool upd = (PWM.CHANNEL[ch].CPRD != period);
  if (period < 1) period = 1;

  if (upd) { while (PWM.SR & (1 << ch)) PWM.DIS = (1 << ch); }
  if (PWM.SR & (1 << ch)) {
    PWM.CHANNEL[ch].CMR |= _PWM_CPD;
    PWM.CHANNEL[ch].CUPD = period;
  } else {
    PWM.CHANNEL[ch].CPRD = period;
  }
  if (upd) PWM.ENA = (1 << ch);
}

void update_duty (int ch, uint16_t dt) {
  ch &= 3;
  if (dt > PWM.CHANNEL[ch].CPRD) dt = PWM.CHANNEL[ch].CPRD;
  if (dt < 2) dt = 2;

  if (PWM.SR & (1 << ch)) {
    PWM.CHANNEL[ch].CMR &= ~_PWM_CPD;
    PWM.CHANNEL[ch].CUPD = dt;
  } else {
    PWM.CHANNEL[ch].CDTY = dt;
  }
}

void PWM_init(void) {
  PMC.PCER = 1 << PWM_PID;

  PWM.DIS = _PWM_CHID0; // PWM disable

  PWM.CHANNEL[0].CMR  = _PWM_CPRE_MCK1024;
  PWM.CHANNEL[0].CPRD = 100;
  duty = PWM.CHANNEL[0].CDTY = 50;

  PWM.ENA = _PWM_CHID0; // PWM enable
}

//========================================================
// main
//========================================================
void main (void) {
  char c = 0;

  enableIRQ ();

  PIO_Configure (pins, PIO_LISTSIZE (pins));
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  // PWMI
  PWM_init ();
  // SPI
  SPI_Init ();

  for (;;) {
    uint16_t w;
    if (_us_rx_buff ()) {
      c = _us_getc ();
      switch (c) {
        case 0x1b:
#if defined (__UDP__)
          udp_disconnect ();
          wait(5000);
#endif
          RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
          break;

        case '0':
          w = _ENM;
          SPI_ATA6831_Send(0);
          st(w, SPI_ATA6831_Send(w));
          break;

        // PWMsgp
        case '1':
          w = _LS3 | _LS2 | _HS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case '2':
          w = _LS3 | _HS2 | _LS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case '3':
          w = _LS3 | _HS2 | _HS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case '4':
          w = _HS3 | _LS2 | _LS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case '5':
          w = _HS3 | _LS2 | _HS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case '6':
          w = _HS3 | _HS2 | _LS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case '7':
          w = _HS3 | _HS2 | _HS1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;

        case '8':
          w = 0xff;
          st(w, SPI_ATA6831_Send(w));
          break;

        // PWMgp
        case 'a':
          w = _LS3 | _LS2 | _HS1 | _PL3 | _PL2 | _PH1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case 'b':
          w = _LS3 | _HS2 | _LS1 | _PL3 | _PH2 | _PL1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case 'c':
          w = _LS3 | _HS2 | _HS1 | _PL3 | _PH2 | _PH1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case 'd':
          w = _HS3 | _LS2 | _LS1 | _PH3 | _PL2 | _PL1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case 'e':
          w = _HS3 | _LS2 | _HS1 | _PH3 | _PL2 | _PH1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case 'f':
          w = _HS3 | _HS2 | _LS1 | _PH3 | _PH2 | _PL1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;
        case 'g':
          w = _HS3 | _HS2 | _HS1 | _PH3 | _PH2 | _PH1 | _ENM;
          st(w, SPI_ATA6831_Send(w));
          break;


        default:
          break;
      }
      _us_rx_purge();
    }

    if (!(PIOA.PDSR & _PB1)) {
      if (++duty > PWM.CHANNEL[0].CPRD) duty = PWM.CHANNEL[0].CPRD;
      update_duty (0, duty);
      st(w, SPI_ATA6831_Send(w));
      wait (200);
    }
    if (!(PIOA.PDSR & _PB2)) {
      if (--duty < 2) duty = 2;
      update_duty (0, duty);
      st(w, SPI_ATA6831_Send(w));
      wait (200);
    }
  }
}
