//-----------------------------------------------------------
// smpl12(tc_toggle).c
// ^C}JE^ɂpXo
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// uU[TIOA2ŗNB
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
static const TPin pins[] = {
  // PB27 -> TIOA2
  {1 << 27, &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
};
#else
static const TPin pins[] = {
  // PA26 -> TIOA2
  {1 << 26, &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_DEFAULT},
};
#endif

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// Timer/Counter2
//========================================================
void TC2_Init (void) {
  // Set up timer
  PMC.PCER = 1 << TC2_PID; // Enable T2 peripheral clock

  TC.CHANNEL[2].CCR = _TC_CLKDIS;
  TC.CHANNEL[2].IDR = -1;
  TC.CHANNEL[2].SR;

  TC.CHANNEL[2].CMR = _TC_CLKS_MCK_8;   // /8
  TC.CHANNEL[2].CMR |= _TC_WAVE | _TC_WAVESEL_UP_AUTO | _TC_ACPC_TOGGLE;  // RC̃RyA}b`TIOAgO
  TC.CHANNEL[2].RC  = 1000;             // /8/RC
  TC.CHANNEL[2].CCR = _TC_CLKEN | _TC_SWTRG;
}

//========================================================
// main
//========================================================
void main (void) {
  enableIRQ ();

  PIO_Configure (pins, PIO_LISTSIZE (pins));
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  TC2_Init ();

  for (;;)  {
    if (_us_rx_buff ()) {
      switch (_us_getc ()) {
        case 0x1b:
#if defined (__UDP__)
          udp_disconnect ();
          wait(5000);
#endif
          RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
          break;
        case 'U':
        case 'u':
          TC.CHANNEL[2].RC += 100;
          TC.CHANNEL[2].CCR = _TC_SWTRG;
          break;
        case 'D':
        case 'd':
          TC.CHANNEL[2].RC -= 100;
          TC.CHANNEL[2].CCR = _TC_SWTRG;
          break;
      }
    }
    _us_printf("\rRC=%5d   ", TC.CHANNEL[2].RC);
    wait (100);
  }
}
