//-----------------------------------------------------------
// smpl15(pit).c
// PITɂC^[o荞
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// PIT̊荞ݔLED𖾖
//
// gグƊ荞ݏԂƃC^[ȏւ
// vOȂȂꍇ̂ŒӁB
// *PA0,PA1,PA2,PA29LEDVNڑ
// *PITSYSC_PIDƂđ̃ytFƊ荞݂L
//  sAꍇɂĊ荞݂̃Gg[[`
//  Kv
//-----------------------------------------------------------
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>
#include <sysc.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#define _LED1 ((uint32_t)1 << 19) // PB19 -> LED1
#define _LED2 ((uint32_t)1 << 20) // PB20 -> LED2
#define _LED3 ((uint32_t)1 << 21) // PB21 -> LED3
#define _LED4 ((uint32_t)1 << 22) // PB22 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#else
#define _LED1 ((uint32_t)1 << 0)  // PA0  -> LED1
#define _LED2 ((uint32_t)1 << 1)  // PA1  -> LED2
#define _LED3 ((uint32_t)1 << 2)  // PA2  -> LED3
#define _LED4 ((uint32_t)1 << 29) // PA29 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#endif
static const TPin pins[] = {
  {_ALL_LED, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
};

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

// w[qHIGH
static __inline__ void PIOA_SetOutput (uint32_t d) {
  PIOA.SODR = d;
}

// w[qLOW
static __inline__ void PIOA_ClearOutput (uint32_t d) {
  PIOA.CODR = d;
}

// 0..3bitLED1..4Ɋ蓖
void pattern (int on) {
  int off;

  on =
    ((on & 1) ? _LED1 : 0)
    | ((on & 2) ? _LED2 : 0)
    | ((on & 4) ? _LED3 : 0)
    | ((on & 8) ? _LED4 : 0);
  off = ~on & _ALL_LED;

  PIOA_SetOutput (off);   // 
  PIOA_ClearOutput (on);  // _
}

//========================================================
// PIT
//========================================================
// 荞ݏ[`
#if defined (__DBGU_INT__) | defined (__DBGU_PDC__)
static void PIT_irq_handler (uint32_t sr) {
  volatile uint32_t dummy;
  static int cnt = 0;

  if (sr & _PIT_PITS) {
    // Read the PIVR. It acknowledges the IT
    dummy = PIT.PIVR;
    pattern (cnt++);
  }
}
#else
void PIT_irq_handler (void) {
  uint32_t sr = PIT.SR;
  volatile uint32_t dummy;
  static int cnt = 0;

  if (PIT.MR & _PIT_PITIEN) {
    sr = PIT.SR;
    if (sr & _PIT_PITS) {
      // Read the PIVR. It acknowledges the IT
      dummy = PIT.PIVR;
      pattern (cnt++);
    }
  }
}
#endif

// ݒ
int PIT_UpdatePeriod (int period) {
  int p;

  PIT.MR = 0;
  p = period ? ((F_CPU >> 4) / period) - 1 : 0;
  if (p > _PIT_PIV) p = _PIT_PIV;
  PIT.MR = _PIT_PITIEN | _PIT_PITEN | (p & _PIT_PIV);

  return p;
}

// 荞ݐݒ
void PIT_InterruptInit (void) {
#if defined (__DBGU_INT__) | defined (__DBGU_PDC__)
  sysc_init ();
  sysc_register(_SYSC_PIT_IRQ, &PIT_irq_handler);
#else
  // Set up timer interrupt
  AIC.IDCR = 1 << SYSC_PID;
  AIC.SVR[SYSC_PID] = (void *)PIT_irq_handler;
  AIC.SMR[SYSC_PID] = 0;
  AIC.ICCR = 1 << SYSC_PID;
  AIC.IECR = 1 << SYSC_PID;
#endif
}

//========================================================
// main
//========================================================
void main (void) {
  int hz = 5, piv, realhz;

  enableIRQ ();
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));
  PIO_Configure (pins, PIO_LISTSIZE (pins));

  PIT_InterruptInit ();
  piv = PIT_UpdatePeriod (hz);

  for (;;)  {
    if (_us_rx_buff ()) {
      switch (_us_getc ()) {
        case 0x1b:
#if defined (__UDP__)
          udp_disconnect ();
          wait(5000);
#endif
          RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
          break;
        case 'U':
          if ((hz+=10) > 3000000) hz = 3000000;
          _us_printf ("\nset period=%7d[Hz], PIV=0x%05X\n", hz, piv = PIT_UpdatePeriod (hz));
          break;
        case 'u':
          if (++hz > 3000000) hz = 3000000;
          _us_printf ("\nset period=%7d[Hz], PIV=0x%05X\n", hz, piv = PIT_UpdatePeriod (hz));
          break;
        case 'D':
          if ((hz-=10) < 1) hz = 1;
          _us_printf ("\nset period=%7d[Hz], PIV=0x%05X\n", hz, piv = PIT_UpdatePeriod (hz));
          break;
        case 'd':
          if (--hz < 1) hz = 1;
          _us_printf ("\nset period=%7d[Hz], PIV=0x%05X\n", hz, piv = PIT_UpdatePeriod (hz));
          break;
      }
    }
    realhz = 300000000 / (piv + 1);
    _us_printf ("now %7d.%02d[Hz]\r", realhz / 100, realhz % 100);
    wait (100);
  }
}
