//-----------------------------------------------------------
// smpl18(udp_mouse).c
// USB}EX
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// UDPɂUSB}EX
//
// ATMELTvgccڐA
//-----------------------------------------------------------
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#include <piocfg.h>
#include <us.h>

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#define _LED1 ((uint32_t)1 << 19) // PB19 -> LED1
#define _LED2 ((uint32_t)1 << 20) // PB20 -> LED2
#define _LED3 ((uint32_t)1 << 21) // PB21 -> LED3
#define _LED4 ((uint32_t)1 << 22) // PB22 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#define _PB1  ((uint32_t)1 << 21) // PA21 -> PB1
#define _PB2  ((uint32_t)1 << 22) // PA22 -> PB2
#define _PB3  ((uint32_t)1 << 23) // PA23 -> PB3
#define _PB4  ((uint32_t)1 << 24) // PA24 -> PB4
#define _ALL_PB  (_PB1 | _PB2 | _PB3 | _PB4)

static const TPin pins[] = {
  {_ALL_LED, &PIOB, PIOB_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_ALL_PB,  &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};
#else
#define _LED1 ((uint32_t)1 << 0)  // PA0  -> LED1
#define _LED2 ((uint32_t)1 << 1)  // PA1  -> LED2
#define _LED3 ((uint32_t)1 << 2)  // PA2  -> LED3
#define _LED4 ((uint32_t)1 << 29) // PA29 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#define _PB1  ((uint32_t)1 << 17) // PA17 -> PB1
#define _PB2  ((uint32_t)1 << 18) // PA18 -> PB2
#define _PB3  ((uint32_t)1 << 19) // PA19 -> PB3
#define _PB4  ((uint32_t)1 << 20) // PA20 -> PB4
#define _ALL_PB  (_PB1 | _PB2 | _PB3 | _PB4)

static const TPin pins[] = {
  {_ALL_LED, &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  {_ALL_PB,  &PIOA, PIOA_PID, PIO_INPUT,    PIO_PULLUP },
};
#endif

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define EP_NUMBER 1

typedef struct _AT91S_HID {
  // Private members
  uint8_t currentConfiguration;
  uint8_t protocol;
  // Public Methods:
  uint8_t (*IsConfigured) (struct _AT91S_HID *pCdc);
  void (*SendReport)(struct _AT91S_HID *pCdc, char button, char x, char y);
} *AT91PS_HID;

const short mouseDescriptor[] = {
  0x0105, // Usage Page (Generic Desktop)
  0x0209, // Usage (Mouse)
  0x01A1, // Collection (Application)
  0x0109, //  Usage (Pointer)
  0x00A1, //  Collection (Physical)
  0x0905, //    Usage Page (Buttons)
  0x0119, //    Usage Minimum (01)
  0x0329, //    Usage Maximum (03)
  0x0015, //    Logical Minimum (0)
  0x0125, //    Logical Maximum (1)
  0x0395, //    Report Count (3)
  0x0175, //    Report Size (1)
  0x0281, //    3 Button bits
  0x0195, //    Report Count (1)
  0x0575, //    Report Size (6)
  0x0181, //    6 bit padding
  0x0105, //    Generic desktop
  0x3009, //    Usage (X)
  0x3109, //    Usage(Y)
  0x8115, //    Logical Minimum (-127)
  0x7F25, //    Logical Maximum (127)
  0x0875, //    Report Size (8)
  0x0295, //    Report Count (2)
  0x0681, //    2 position bytes
  0xC0C0
};

// Check http://www.usb.org/developers/hidpage/#Class_Definition
const char devDescriptor[] = {
  /* Device descriptor */
  0x12,   // bLength
  0x01,   // bDescriptorType
  0x10,   // bcdUSBL
  0x01,   //
  0x00,   // bDeviceClass:
  0x00,   // bDeviceSubclass:
  0x00,   // bDeviceProtocol:
  0x08,   // bMaxPacketSize0
  0xFF,   // idVendorL
  0xFF,   //
  0x00,   // idProductL
  0x00,   //
  0x01,   // bcdDeviceL
  0x00,   //
  0x00,   // iManufacturer    // 0x01
  0x00,   // iProduct
  0x00,   // SerialNumber
  0x01    // bNumConfigs
};

const char cfgDescriptor[] = {
  /* ============== CONFIGURATION 1 =========== */
  /* Configuration 1 descriptor */
  0x09,   // CbLength
  0x02,   // CbDescriptorType
  0x22,   // CwTotalLength 2 EP + Control
  0x00,
  0x01,   // CbNumInterfaces
  0x01,   // CbConfigurationValue
  0x00,   // CiConfiguration
  0xC0,   // CbmAttributes Bus powered
  0x32,   // CMaxPower: 100mA

  /* Mouse Interface Descriptor Requirement */
  0x09,   // bLength
  0x04,   // bDescriptorType
  0x00,   // bInterfaceNumber
  0x00,   // bAlternateSetting
  0x01,   // bNumEndpoints
  0x03,   // bInterfaceClass: HID code
  0x01,   // bInterfaceSubclass
  0x02,   // bInterfaceProtocol: Mouse
  0x00,   // iInterface

  /* HID Descriptor */
  0x09,   // bLength
  0x21,   // bDescriptor type: HID Descriptor Type
  0x00,   // bcdHID
  0x01,
  0x00,   // bCountryCode
  0x01,   // bNumDescriptors
  0x22,   // bDescriptorType
  sizeof(mouseDescriptor), // wItemLength
  0x00,

  /* Endpoint 1 descriptor */
  0x07,   // bLength
  0x05,   // bDescriptorType
  0x80 + EP_NUMBER,   // bEndpointAddress, Endpoint 01 - OUT
  0x03,   // bmAttributes      INT
  0x04,   // wMaxPacketSize: 3 bytes (button, x, y)
  0x00,
  0x0A    // bInterval
};

/* USB standard request code */
#define STD_GET_STATUS_ZERO             0x0080
#define STD_GET_STATUS_INTERFACE        0x0081
#define STD_GET_STATUS_ENDPOINT         0x0082

#define STD_CLEAR_FEATURE_ZERO          0x0100
#define STD_CLEAR_FEATURE_INTERFACE     0x0101
#define STD_CLEAR_FEATURE_ENDPOINT      0x0102

#define STD_SET_FEATURE_ZERO            0x0300
#define STD_SET_FEATURE_INTERFACE       0x0301
#define STD_SET_FEATURE_ENDPOINT        0x0302

#define STD_SET_ADDRESS                 0x0500
#define STD_GET_DESCRIPTOR              0x0680
#define STD_SET_DESCRIPTOR              0x0700
#define STD_GET_CONFIGURATION           0x0880
#define STD_SET_CONFIGURATION           0x0900
#define STD_GET_INTERFACE               0x0A81
#define STD_SET_INTERFACE               0x0B01
#define STD_SYNCH_FRAME                 0x0C82

/* HID Class Specific Request Code */
#define CLASS_GET_HID_DESCRIPTOR        0x0681
#define CLASS_SET_IDLE                  0x0A21
#define CLASS_SET_PROTOCOL              0x0B21
#define CLASS_GET_PROTOCOL              0x03A1

struct _AT91S_HID HID;

static uint8_t UDP_IsConfigured (AT91PS_HID);
static void HID_SendReport (AT91PS_HID, char button, char x, char y);
static void HID_Enumerate (AT91PS_HID);

//========================================================
// MISC...
//========================================================
static __inline__ void PIOA_SetOutput (uint32_t d) {
  PIOA.SODR = d;
}

static __inline__ void PIOA_ClearOutput (uint32_t d) {
  PIOA.CODR = d;
}

//========================================================
// UDP
//========================================================
AT91PS_HID HID_Open (AT91PS_HID pHid) {
  pHid->currentConfiguration = 0;
  pHid->protocol = 1;
  pHid->IsConfigured = UDP_IsConfigured;
  pHid->SendReport   = HID_SendReport;
  return pHid;
}

//----------------------------------------------------------------------------
static uint8_t UDP_IsConfigured (AT91PS_HID pHid) {
  uint32_t isr = UDP.ISR;

  if (isr & _UDP_ENDBUSRES) {
    UDP.ICR = _UDP_ENDBUSRES;
    // reset all endpoints
    UDP.RST_EP = (uint32_t) -1;
    UDP.RST_EP = 0;
    // Enable the function
    UDP.FADDR = _UDP_FEN;
    // Configure endpoint 0
    UDP.CSR[0] = (_UDP_EPEDS | _UDP_EPTYPE_CTRL);
  } else if (isr & _UDP_EP0INT) {
    HID_Enumerate (pHid);
  }
  return pHid->currentConfiguration;
}

//----------------------------------------------------------------------------
static void HID_SendReport(AT91PS_HID pHid, char button, char x, char y) {
  // Send report to the host
  UDP.FDR[EP_NUMBER] = button;
  UDP.FDR[EP_NUMBER] = x;
  UDP.FDR[EP_NUMBER] = y;
  UDP.CSR[EP_NUMBER] |= _UDP_TXPKTRDY;

  // Wait for the end of transmission
  while (!(UDP.CSR[EP_NUMBER] & _UDP_TXCOMP))
    UDP_IsConfigured(pHid);

  // Clear _UDP_TXCOMP flag
  if (UDP.CSR[EP_NUMBER] & _UDP_TXCOMP) {
    UDP.CSR[EP_NUMBER] &= ~(_UDP_TXCOMP);
    while (UDP.CSR[EP_NUMBER] & _UDP_TXCOMP);
  }
}

//----------------------------------------------------------------------------
static void USB_SendData (const char *pData, uint32_t length) {
  uint32_t cpt = 0;
  uint32_t csr;

  do {
    cpt = MIN (length, 8);
    length -= cpt;

    while (cpt--)
      UDP.FDR[0] = *pData++;

    if (UDP.CSR[0] & _UDP_TXCOMP) {
      UDP.CSR[0] &= ~(_UDP_TXCOMP);
      while (UDP.CSR[0] & _UDP_TXCOMP);
    }

    UDP.CSR[0] |= _UDP_TXPKTRDY;
    do {
      csr = UDP.CSR[0];

      // Data IN stage has been stopped by a status OUT
      if (csr & _UDP_RX_DATA_BK0) {
        UDP.CSR[0] &= ~(_UDP_RX_DATA_BK0);
        return;
      }
    } while ( !(csr & _UDP_TXCOMP) );

  } while (length);

  if (UDP.CSR[0] & _UDP_TXCOMP) {
    UDP.CSR[0] &= ~(_UDP_TXCOMP);
    while (UDP.CSR[0] & _UDP_TXCOMP);
  }
}

//----------------------------------------------------------------------------
void USB_SendZlp (void) {
  UDP.CSR[0] |= _UDP_TXPKTRDY;
  while (!(UDP.CSR[0] & _UDP_TXCOMP));
  UDP.CSR[0] &= ~(_UDP_TXCOMP);
  while (UDP.CSR[0] & _UDP_TXCOMP);
}

//----------------------------------------------------------------------------
void USB_SendStall (void) {
  UDP.CSR[0] |= _UDP_FORCESTALL;
  while (!(UDP.CSR[0] & _UDP_ISOERROR));
  UDP.CSR[0] &= ~(_UDP_FORCESTALL | _UDP_ISOERROR);
  while (UDP.CSR[0] & (_UDP_FORCESTALL | _UDP_ISOERROR));
}

//----------------------------------------------------------------------------
static void HID_Enumerate (AT91PS_HID pHid) {
  uint8_t bmRequestType, bRequest;
  uint16_t wValue, wIndex, wLength, wStatus;

  if (!(UDP.CSR[0] & _UDP_RXSETUP)) return;

  bmRequestType = UDP.FDR[0];
  bRequest      = UDP.FDR[0];
  wValue        = (UDP.FDR[0] & 0xFF);
  wValue       |= (UDP.FDR[0] << 8);
  wIndex        = (UDP.FDR[0] & 0xFF);
  wIndex       |= (UDP.FDR[0] << 8);
  wLength       = (UDP.FDR[0] & 0xFF);
  wLength      |= (UDP.FDR[0] << 8);

  if (bmRequestType & 0x80) {
    UDP.CSR[0] |= _UDP_DIR;
    while ( !(UDP.CSR[0] & _UDP_DIR) );
  }
  UDP.CSR[0] &= ~_UDP_RXSETUP;
  while ( (UDP.CSR[0]  & _UDP_RXSETUP)  );

  // Handle supported standard device request Cf Table 9-3 in USB specification Rev 1.1
  switch ((bRequest << 8) | bmRequestType) {
    case STD_GET_DESCRIPTOR:
      if (wValue == 0x100)       // Return Device Descriptor
        USB_SendData (devDescriptor, MIN (sizeof (devDescriptor), wLength));
      else if (wValue == 0x200)  // Return Configuration Descriptor
        USB_SendData (cfgDescriptor, MIN (sizeof (cfgDescriptor), wLength));
      else
        USB_SendStall ();
      break;
    case STD_SET_ADDRESS:
      USB_SendZlp ();
      UDP.FADDR = (_UDP_FEN | wValue);
      UDP.GLB_STAT  = (wValue) ? _UDP_FADDEN : 0;
      break;
    case STD_SET_CONFIGURATION:
      pHid->currentConfiguration = wValue;
      USB_SendZlp ();
      UDP.GLB_STAT  = (wValue) ? _UDP_CONFG : _UDP_FADDEN;
      UDP.CSR[EP_NUMBER] = (wValue) ? (_UDP_EPEDS | _UDP_EPTYPE_BULK_IN)   : 0;
      break;
    case STD_GET_CONFIGURATION:
      USB_SendData ((char *)&(pHid->currentConfiguration), sizeof(pHid->currentConfiguration));
      break;
    case CLASS_SET_PROTOCOL:
      pHid->protocol = wValue;
      USB_SendZlp ();
      break;
    case CLASS_GET_PROTOCOL:
      USB_SendData ((char *)&(pHid->protocol), sizeof (pHid->protocol));
      break;
    case STD_GET_STATUS_ZERO:
      wStatus = 0;
      USB_SendData ((char *)&wStatus, sizeof (wStatus));
      break;
    case STD_GET_STATUS_INTERFACE:
      wStatus = 0;
      USB_SendData ((char *)&wStatus, sizeof (wStatus));
      break;
    case STD_GET_STATUS_ENDPOINT:
      wStatus = 0;
      wIndex &= 0x0F;
      if ((UDP.GLB_STAT & _UDP_CONFG) && (wIndex <= 3)) {
        wStatus = (UDP.CSR[wIndex] & _UDP_EPEDS) ? 0 : 1;
        USB_SendData ((char *)&wStatus, sizeof (wStatus));
      }
      else if ((UDP.GLB_STAT & _UDP_FADDEN) && (wIndex == 0)) {
        wStatus = (UDP.CSR[wIndex] & _UDP_EPEDS) ? 0 : 1;
        USB_SendData ((char *)&wStatus, sizeof (wStatus));
      }
      else
        USB_SendStall ();
      break;
    case STD_SET_FEATURE_ZERO:
      USB_SendStall ();
        break;
    case STD_SET_FEATURE_INTERFACE:
      USB_SendZlp ();
      break;
    case STD_SET_FEATURE_ENDPOINT:
      wIndex &= 0x0F;
      if ((wValue == 0) && wIndex && (wIndex <= 3)) {
        UDP.CSR[wIndex] = 0;
        USB_SendZlp ();
      }
      else
        USB_SendStall ();
      break;
    case STD_CLEAR_FEATURE_ZERO:
      USB_SendStall ();
        break;
    case STD_CLEAR_FEATURE_INTERFACE:
      USB_SendZlp ();
      break;
    case STD_CLEAR_FEATURE_ENDPOINT:
      wIndex &= 0x0F;
      if ((wValue == 0) && wIndex && (wIndex <= 3)) {
        if (wIndex == 1)
          UDP.CSR[1] = (_UDP_EPEDS | _UDP_EPTYPE_BULK_OUT);
        else if (wIndex == 2)
          UDP.CSR[2] = (_UDP_EPEDS | _UDP_EPTYPE_BULK_IN);
        else if (wIndex == 3)
          UDP.CSR[3] = (_UDP_EPEDS | _UDP_EPTYPE_ISO_IN);
        USB_SendZlp ();
      }
      else
        USB_SendStall ();
      break;

    // handle HID class requests
    case CLASS_GET_HID_DESCRIPTOR:
      if (wValue == 0x2200)       // Return Mouse Descriptor
        USB_SendData ((const char *)mouseDescriptor, MIN(sizeof(mouseDescriptor), wLength));
      else if (wValue == 0x2100) // Return HID descriptor
        USB_SendData (&cfgDescriptor[18], MIN(0x09, wLength));
      else
        USB_SendStall ();
      break;

    case CLASS_SET_IDLE:
      USB_SendZlp ();
      break;

    default:
      USB_SendStall ();
        break;
  }
}

//----------------------------------------------------------------------------
void USB_Open(void) {
  // Set the PLL USB Divider
  PMC.PLLR |= ((uint32_t) 0x1 << 28);
  // Specific Chip USB Initialisation
  // Enables the 48MHz USB clock UDPCK and System Peripheral USB Clock
  PMC.SCER = ((uint32_t) 0x1 <<  7);
  PMC.PCER = (1 << UDP_PID);
  // Enable UDP PullUp (USB_DP_PUP) : enable & Clear of the corresponding PIO
  // Set in PIO mode and Configure in Output
  PIOA.PER = ((uint32_t) 1 << 16); // Set in PIO mode
  PIOA.OER = ((uint32_t) 1 << 16); // Configure in Output
  // Clear for set the Pul up resistor
  PIOA.CODR = ((uint32_t) 1 << 16);
  // CDC Open by structure initialization
  HID_Open (&HID);
}

//========================================================
// main
//========================================================
#define BL_OFF(pio) ((pio) & _PB1)
#define BR_OFF(pio) ((pio) & _PB2)
#define BU_OFF(pio) ((pio) & _PB3)
#define BD_OFF(pio) ((pio) & _PB4)

#define BL_ON(pio)  (!BL_OFF(pio))
#define BR_ON(pio)  (!BR_OFF(pio))
#define BU_ON(pio)  (!BU_OFF(pio))
#define BD_ON(pio)  (!BD_OFF(pio))

#define CLICKL_ON   1
#define CLICKR_ON   2

#define BUTTON_SAMPLING 1000 // Sampling frequency of buttons

int main (void) {
  char prevButton = 0, button = 0;
  int x = 0, y = 0;
  uint32_t pioStatus;

  dbgu_init (115200);       // Init trace DBGU
  USB_Open ();              // Init USB device
  RTT.MR = BUTTON_SAMPLING; // Configure the RTT:

  // Set in PIO mode and Configure in Input
  PIO_Configure (pins, PIO_LISTSIZE (pins));

  PIOA_SetOutput (_LED1 | _LED2 | _LED3 | _LED4);  // Leds are switched off
  PIOA_ClearOutput (_LED1);          // Led1 is switched on
  while (!HID.IsConfigured (&HID))  // Wait for the end of enumeration
    dbgu_printf(".");

  PIOA_ClearOutput (_LED1 | _LED2 | _LED3 | _LED4);  // Leds are switched on

  while (1) {
    // Start waiting some cmd
    if (HID.IsConfigured (&HID) && (RTT.SR & ((uint32_t) 0x1 << 1))) {
      dbgu_printf(" %4d %4d \r", x, y);
      pioStatus = PIOA.PDSR;      // Check PIO changes
      // Click on Button Left
      if (BL_ON (pioStatus) && BR_OFF (pioStatus)) {
        x = (x > 0) ? -1 : ((-127 < x) ? --x : x);
        PIOA_ClearOutput (_LED2);
        PIOA_SetOutput (_LED1);
      // Click on Button Right
      } else if (BL_OFF (pioStatus) && BR_ON (pioStatus)) {
        x = (x < 0) ? 0 : ((x < 127) ? ++x : x);
        PIOA_ClearOutput (_LED1);
        PIOA_SetOutput (_LED2);
      // Click on Both
      } else if (BL_ON (pioStatus) && BR_ON (pioStatus)) {
        button |= CLICKL_ON;
        x = 0;
        PIOA_SetOutput (_LED1 | _LED2);
      // Release right/left button
      } else {
        button &= ~(CLICKL_ON);
        x = 0;
        PIOA_ClearOutput (_LED1 | _LED2);
      }
      if (BU_ON (pioStatus) && BD_OFF (pioStatus)) {
        y = (y > 0) ? -1 : ((-127 < y) ? --y : y);
        PIOA_ClearOutput (_LED4);
        PIOA_SetOutput (_LED3);
      } else if (BU_OFF (pioStatus) && BD_ON (pioStatus)) {
        y = (y < 0) ? 0 : ((y < 127) ? ++y : y);
        PIOA_ClearOutput (_LED3);
        PIOA_SetOutput (_LED4);
      } else if (BU_ON (pioStatus) && BD_ON (pioStatus)) {
        button |= CLICKR_ON;
        y = 0;
        PIOA_SetOutput (_LED3 | _LED4);
      } else {
        button &= ~(CLICKR_ON);
        y = 0;
        PIOA_ClearOutput (_LED3 | _LED4);
      }

      // Send Coordinates
      if ((prevButton != button) || x || y) {
        prevButton = button;
        HID.SendReport (&HID, button, x, y);
      }
    }
  }
}
