//-----------------------------------------------------------
// smpl9(spi_lisS331).c
// SPIڑ̉xZT(LIS331DL)Ƃ̒ʐM
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// LIS331DL̏ڍׂ͈ȉ
//  http://www.st.com/stonline/products/families/sensors/motion_sensors/lis331dl.htm
// SPȊMPDCgpB
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

// PIO[qݒ
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
static const TPin pins[] = {
  // PA16 -> SPI0(MISO)
  {1 << 16,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_PULLUP},
  // PA17 -> SPI0(MOSI)
  {1 << 17,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA18 -> SPI0(SPCK)
  {1 << 18,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA13 -> SPI0(NPCS1) -> LIS331DL
  {1 << 13,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA14 -> SPI0(NPCS2) -> ATA6831
  {1 << 14,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
};

#define SPI SPI0

#else
static const TPin pins[] = {
  // PA12 -> SPI(MISO)
  {1 << 12,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_PULLUP},
  // PA13 -> SPI(MOSI)
  {1 << 13,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA14 -> SPI(SPCK)
  {1 << 14,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA31 -> SPI(NPCS1) -> LIS331DL
  {1 << 31,       &PIOA, PIOA_PID, PIO_PERIPH_A, PIO_DEFAULT},
  // PA30 -> SPI(NPCS2) -> ATA6831
  {1 << 30,       &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_DEFAULT},
};
#endif

//========================================================
// MISC...
//========================================================
// ʃ[vɂȈՃEFCg֐
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// SPI
//========================================================
// TX & RX (use PDC)
void SPI_SendReceive (void *tbuf, void *rbuf, int len) {
  // Check if first bank is free
  while (!(SPI.SR & _SPI_ENDTX)) ;
  if (SPI.PDC.TCR == 0) {
    SPI.PDC.RPR = rbuf;
    SPI.PDC.RCR = len;
    SPI.PDC.TPR = tbuf;
    SPI.PDC.TCR = len;
    SPI.PDC.PTCR = _PDC_TXTEN;
  }
  // Check if second bank is free
  else if (SPI.PDC.TNCR == 0) {
    SPI.PDC.RNPR = rbuf;
    SPI.PDC.RNCR = len;
    SPI.PDC.TNPR = tbuf;
    SPI.PDC.TNCR = len;
  }
  while (!(SPI.SR & _SPI_ENDRX)) ;
}

// Init SPI
void SPI_Init (void) {
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
  PMC.PCER = 1 << SPI0_PID;
#else
  PMC.PCER = 1 << SPI_PID;
#endif

  SPI.PDC.PTCR = _PDC_RXTDIS | _PDC_TXTDIS;
  SPI.CR = _SPI_SWRST | _SPI_SPIDIS;
  SPI.MR = _SPI_MSTR | _SPI_PS | _SPI_PS_FIXED | _SPI_MODFDIS | (0xf << 16);

  // LIS3LV02DL
  SPI.CSR[1] = _SPI_CPOL |              _SPI_CSAAT | _SPI_BITS_8  | ((uint32_t) 14 << 8);

  SPI.PDC.TNPR = SPI.PDC.RNPR = SPI.PDC.TPR = SPI.PDC.RPR = (uint8_t *)0;
  SPI.PDC.TNCR = SPI.PDC.RNCR = SPI.PDC.TCR = SPI.PDC.RCR = 0;
  SPI.PDC.PTCR = _PDC_RXTEN | _PDC_TXTEN;

  SPI.CR = _SPI_SPIEN;
}

//========================================================
// LIS331DL I/F
//========================================================
#define _LIS3_RW_R ((uint8_t) 1 << 7)
#define _LIS3_RW_W ((uint8_t) 0 << 7)
#define _LIS3_MS_M ((uint8_t) 1 << 6)
#define _LIS3_MS_S ((uint8_t) 0 << 6)

void SPI_LIS3_WriteReg (uint8_t addr, uint8_t size, uint8_t *senddata) {
  uint32_t tbuf[21], rbuf[21];
  uint32_t i, b;
  uint8_t *t = senddata;
  // 20oCg܂ŃT|[g
  if (size > 20) return;
  // Mf[^쐬
  for (i = 0; i <= size; i++) {
    // 擪oCg\
    if (i == 0) b = 0xd0000 | _LIS3_RW_W | _LIS3_MS_M | (addr & 0x3f);
    // ŏIoCg\
    else if (i == size) b = 0xd0000 | _SPI_LASTXFER | *t++;
    // ԃf[^\
    else b = 0xd0000 | *t++;
    tbuf[i] = b;
  }
  // M
  SPI_SendReceive ((void *)tbuf, rbuf, size + 1);
}

uint8_t *SPI_LIS3_ReadReg (uint8_t addr, uint8_t size, uint8_t *readdata) {
  uint32_t tbuf[21], rbuf[21];
  uint32_t i, b;
  uint8_t *t = readdata;
  // 20oCg܂ŃT|[g
  if (size > 20) return 0;
  // Mf[^쐬
  for (i = 0; i <= size; i++) {
    // 擪oCg\
    if (i == 0) b = 0xd0000 | _LIS3_RW_R | _LIS3_MS_M | (addr & 0x3f);
    // ŏIoCg\
    else if (i == size) b = 0xd0000 | _SPI_LASTXFER;
    // ԃf[^\
    else b = 0xd0000;
    tbuf[i] = b;
  }
  // M
  SPI_SendReceive ((void *)tbuf, rbuf, size + 1);
  // 擾f[^Rs[
  for (i = 0; i < size; i++) *t++ = rbuf[i + 1];
  return readdata;
}

//========================================================
// main
//========================================================
void main (void) {
  signed short x,y,z;
  char c = 0;
  uint8_t dat[10];

  enableIRQ ();
  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));
  PIO_Configure (pins, PIO_LISTSIZE (pins));
  SPI_Init ();

  // LIS331DLCl[u
  dat[0] = 0xc7;
  SPI_LIS3_WriteReg (0x20, 1, dat);

  _us_printf ("START!\n\r");

  for (;;) {
    if (_us_rx_buff ()) _us_putc (c = _us_getc ());
    switch (c) {
      case 0x1b:
#if defined (__UDP__)
        udp_disconnect ();
        wait(5000);
#endif
        RSTC.CR = 0xA5000000 | _RSTC_PROCRST | _RSTC_PERRST | _RSTC_EXTRST;
        break;
      case 'w': // Who am i WX^ǂݏo
        _us_printf ("\r\x1b[KWHO_AM_I = $%02X", *SPI_LIS3_ReadReg (0x0f, 1, dat));
        break;
      case '2': // XP[2GɕύX
        dat[0] = 0xc7;
        SPI_LIS3_WriteReg (0x20, 1, dat);
        _us_printf ("\r\x1b[KFULLSCALE WAS CHANGED to 2G");
        c = ' ';
        break;
      case '8': // XP[8GɕύX
        dat[0] = 0xe7;
        SPI_LIS3_WriteReg (0x20, 1, dat);
        _us_printf ("\r\x1b[KFULLSCALE WAS CHANGED to 8G");
        c = ' ';
        break;
      case 'i': // CTRL_REG1/2/3ǂݏo
        SPI_LIS3_ReadReg (0x20, 3, &dat[0]);
        _us_printf ("\r\x1b[KCTRL_REG = $%02X $%02X $%02X", dat[0], dat[1], dat[2]);
        c = ' ';
        break;
      case 's': // STATUS_REGǂݏo
        _us_printf ("\r\x1b[KSTATUS_REG = $%02X", *SPI_LIS3_ReadReg (0x27, 1, &dat[0]));
        break;
      case 'g': // OUT_X/Y/Zǂݏo
        SPI_LIS3_ReadReg (0x28, 6, &dat[0]);
#if 1
        x = (signed char)dat[1];
        y = (signed char)dat[3];
        z = (signed char)dat[5];
#else
        x = ((signed short)((u16)(dat[1] << 8) | (u16)(dat[0]))) / 256;
        y = ((signed short)((u16)(dat[3] << 8) | (u16)(dat[2]))) / 256;
        z = ((signed short)((u16)(dat[5] << 8) | (u16)(dat[4]))) / 256;
#endif
        _us_printf ("\r\x1b[Kx:%5d y:%5d z:%5d", x, y, z);
        break;
      default:
        break;
    }
    wait (100);
  }
}
